from bob import BobConn
import bob as BOB
import time
import util

def closetun(nick):
    stop(nick)
    clear(nick)
def stop(nick):
    bob = BOB.BobConn()
    try:
        bob.getnick(nick)
        bob.stop()
        while bob.show()['stopping'] == 'true':
            time.sleep(.5)
    except Exception as E:
        if util.DEBUG == True:
            print repr(E)
    bob.quit()
    bob.close()
def clear(nick):
    bob = BOB.BobConn()
    try:
        bob.getnick(nick)
        bob.clear()##assumes tunnel is fully stoped
    except Exception as E:
        if util.DEBUG == True:
            print repr(E)
    bob.quit()
    bob.close()
def init_tun(bob):
    bob.quiet('true')
    bob.start()
    while bob.show()['starting'] == 'true':
        time.sleep(.5)
    bob.quit()
    bob.close()
##to connect to a dest, open a socket to port, and send dest/b32 + "\n"
class CliForw():
    def __init__(self,addr):
        self.nick = "I2PYC"+addr[:5]
        bob = BobConn()
        try:
            bob.getnick(self.nick)
            info = bob.show()
            if info['running'] == 'false':
                init_tun(bob)##if inport is already used by diff tunnel, bob.start will raise
            self.port = int(info['inport'])
        except:
            try:
                bob.setnick(self.nick)
            except:
                print "exception in get and setnick, probably port already in use"
                bob.getnick(self.nick)
            bob.newkeys()
            self.port = util.RandPort()
            bob.SetIN(BOB.BOB_IP,self.port)
            init_tun(bob)
    def close(self):
        stop(self.nick)
##creates an i2p tunnel that forwards connections to a local port
class ServForw():
    def __init__(self,port,private="",nick=""):
        bob = BobConn()
        if private == "":
            if nick == "":
                self.nick = 'I2PYL'+util.RandNick()
            else:
                self.nick = nick
            bob.setnick(self.nick)
            bob.newkeys()
        else:
            if nick == "":##will raise if tunnel exists under different nick
                self.nick = 'L'+util.RandNick()
                bob.setnick(self.nick)
                bob.setkeys(private)
            else:
                self.nick = nick
                try:
                    bob.getnick(self.nick)
                    bob.stop()
                    while bob.show()['stopping'] == 'true':
                        time.sleep(1)
                    bob.setkeys(private)
                except:
                    bob.setnick(self.nick)
                    bob.setkeys(private)
        bob.getdest()
        bob.getkeys()
        self.public = bob.public
        self.b32 = bob.b32
        self.private = bob.private
        bob.SetOUT(BOB.COMP_IP,port)
        init_tun(bob)
    def close(self):
        closetun(self.nick)##ServForws stop and clear on forw.close
