import tarfile
import patch11
import os
import shutil

sumo = './allmydata-tahoe-1.8.2-SUMO'
allsrcpth = sumo+'/src/allmydata/'
nodepath = allsrcpth+'node.py'
tahoedeps = sumo+'/tahoe-deps'
twisted = 'Twisted-10.2.0'
tcppath = twisted+'/twisted/internet/tcp.py'
stclpth = allsrcpth+'storage_client.py'
clipth = allsrcpth+'client.py'

def extract(name,typ):
    T = tarfile.open(name+'.tar.'+typ,'r:'+typ)
    T.extractall()
    T.close()
def mvpatch(path,diff):
    fname = './'+path.split('/')[-1]
    os.rename(path,fname)
    patch = patch11.fromfile(diff)
    rslt = patch.apply()
    os.rename(fname,path)
    
extract(sumo,'bz2')
mvpatch(nodepath,'./node.diff')
mvpatch(stclpth,'./storage_client.diff')
mvpatch(clipth,'./client.diff')
extract(tahoedeps+'/'+twisted,'gz')
mvpatch(tcppath,'./tcp.diff')
os.remove(tahoedeps+'/'+twisted+'.tar.gz')
T = tarfile.open(tahoedeps+'/'+twisted+'.tar.gz','w:gz')
T.add(twisted)
T.close()
shutil.rmtree(twisted)
os.rename(sumo,'i2py-tahoe-1.8.2-SUMO')
